#!/usr/bin/perl
##
# Fetcher for IMDB's pages.
#
#

package TopFilms::IMDB;

use TopFilms;
@ISA = ('TopFilms');



##
# Our name.
sub name
{
    return "IMDB";
}


##
# Return the charts that we handle.
sub getCharts
{
    my @genres = (
              'Action',
              'Adventure',
              'Animation',
              'Biography',
              'Comedy',
              'Crime',
              'Drama',
              'Family',
              'Fantasy',
              'Film-Noir',
              'History',
              'Horror',
              'Music',
              'Musical',
              'Mystery',
              'Romance',
              'Sci-Fi',
              'Sport',
              'Thriller',
              'War',
              'Western'
        );
    return {
            map {
                # The URLs have _s instead of -s.
                my $url = lc $_;
                $url =~ tr/-/_/;
                
                ($_ =>
                    {
                        'name' => $_,
                        'url' => [ map { 'http://www.imdb.com/search/title?at=0&genres=' . $url . '&sort=moviemeter,asc&start='. ($_*50+1) .'&title_type=feature' } (0..4) ],
                    })
            } @genres
        };
}


##
# Patterns to apply for a chart's page.
sub pattern
{
    return {
            'entry'     => qr/tr class="(?:even|odd) detailed">(.*?)<\/tr>/is,
            'number'    => qr/<td class="number">(\d+)\.<\/td>/,
            'title'     => qr/<a href="\/title\/tt\d+\/">([^<]+)<\/a>/,
            'year'      => qr/<span class="year_type">\((\d\d\d\d)\)<\/span>/,
        };
}


# Modules must return true.
1;
